Classes
Protocols
Constants
Functions
Macros
Types
Variables

### Classes

EOAggregateEvent
EOAndQualifier
EOArrayDataSource
EOClassDescription
EOCooperatingObjectStore
EOCustomObject
EODataSource
EODelayedObserver
EODelayedObserverQueue
EODetailDataSource
EOEditingContext
EOEvent
EOEventCenter
EOFault
EOFaultHandler
EOFetchSpecification
EOGenericRecord
EOGlobalID
EOKeyComparisonQualifier
EOKeyGlobalID
EOKeyValueArchiver
EOKeyValueQualifier
EOKeyValueUnarchiver
EOMultiReaderLock
EONotQualifier
EOObjectStore
EOObjectStoreCoordinator
EOObserverCenter
EOObserverProxy
EOOrQualifier
EOQualifier
EOQualifierVariable
EOSharedEditingContext
EOSortOrdering
EOTemporaryGlobalID
EOUndoManager

### Protocols

<EOEventRecordingHandler>
<EOKeyValueArchiving>
<EOObserving>
<EOQualifierEvaluation>
(Comparison)
(EODeprecated)
(EOEditingContextDelegation)
(EOEventRecordingHandler)
(EOKVCGDL2Additions)
(EOKeyValueCoding)
(EOKeyValueCodingAdditions)
(MacOSX)

### Constants

### Functions

EOCancelEvent
EOEditingContext_globalIDForObjectWithImpPtr
EOEditingContext_objectForGlobalIDWithImpPtr
EOEditingContext_recordObjectGlobalIDWithImpPtr
EOFLogAssertGood_
EOFLogC_
EOFLogDumpObject_
EOHashAddTable
EOMKKDInitializer_indexForKeyWithImpPtr
EOMKKD_hasKeyWithImpPtr
EOMKKD_indexForKeyWithImpPtr
EOMKKD_objectForKeyWithImpPtr
EOMKKD_removeObjectForKeyWithImpPtr
EOMKKD_setObjectForKeyWithImpPtr
EOMarkAtomicEvent
EOMarkEndOfEvent
EOMarkStartOfEvent
EONewEventOfClass
GDL2_Activate
GDL2_AssignAtomicallyIfNil
GDL2_PrivateInit
GDL2_isLegalDBName
GSUseStrictWO451Compatibility

### Macros

GDL2_BUFFER

### Types

EODeleteRule
EOEventSignatureType
EOObserverPriority

### Variables

EOAdditionalExceptionsKey
EOClassDescriptionNeededForClassNotification
EOClassDescriptionNeededForEntityNameNotification
EOClassDescriptionNeededNotification
EOCooperatingObjectStoreNeeded
EOCooperatingObjectStoreWasAdded
EOCooperatingObjectStoreWasRemoved
EODefaultSharedEditingContextWasInitializedNotification
EODeletedKey
EOEditingContextDidSaveChangesNotification
EOEventGroupName
EOEventLoggingEnabled
EOEventLoggingLimit
EOEventLoggingOverflowDisplay
EOFetchLimitHintKey
EOGlobalIDChangedNotification
EOInsertedKey
EOInvalidatedAllObjectsInStoreNotification
EOInvalidatedKey
EOObjectsChangedInEditingContextNotification
EOObjectsChangedInStoreNotification
EOPrefetchingRelationshipHintKey
EOPromptAfterFetchLimitHintKey
EOQualifierVariableSubstitutionException
EOSharedEditingContextInitializedObjectsNotification
EOTargetObjectUserInfoKey
EOUnknownUserInfoKey
EOUpdatedKey
EOValidatedObjectUserInfoKey
EOValidatedPropertyUserInfoKey
EOValidationException
GDL2_EOEditingContextClass
GDL2_EOEditingContext_globalIDForObjectIMP
GDL2_EOEditingContext_objectForGlobalIDIMP
GDL2_EOEditingContext_recordObjectGlobalIDIMP
GDL2_EOFaultClass
GDL2_EOMKKDInitializerClass
GDL2_EOMKKDInitializer_indexForKeyIMP
GDL2_EONull
GDL2_Lock
GDL2_MKKDClass
GDL2_MKKD_hasKeyIMP
GDL2_MKKD_indexForKeyIMP
GDL2_MKKD_objectForKeyIMP
GDL2_MKKD_removeObjectForKeyIMP
GDL2_MKKD_setObjectForKeyIMP
GDL2_NSArray
GDL2_NSArrayClass
GDL2_NSArray_arrayIMP
GDL2_NSAutoreleasePoolClass
GDL2_NSAutoreleasePool_newIMP
GDL2_NSCalendarDateClass
GDL2_NSCalendarDate_allocWithZoneIMP
GDL2_NSDataClass
GDL2_NSData_allocWithZoneIMP
GDL2_NSData_dataWithBytes_lengthIMP
GDL2_NSDateClass
GDL2_NSDecimalNumberClass
GDL2_NSDecimalNumber_allocWithZoneIMP
GDL2_NSDictionaryClass
GDL2_NSMutableArrayClass
GDL2_NSMutableArray_allocWithZoneIMP
GDL2_NSMutableArray_arrayIMP
GDL2_NSMutableArray_arrayWithArrayIMP
GDL2_NSMutableArray_arrayWithCapacityIMP
GDL2_NSMutableDictionaryClass
GDL2_NSMutableDictionary_allocWithZoneIMP
GDL2_NSMutableDictionary_dictionaryWithCapacityIMP
GDL2_NSNumberBool_No
GDL2_NSNumberBool_Yes
GDL2_NSNumberClass
GDL2_NSNumber_allocWithZoneIMP
GDL2_NSStringClass
GDL2_NSString_allocWithZoneIMP
GDL2_NSString_defaultCStringEncodingIMP
GDL2_NSString_stringWithCStringIMP
GDL2_NSString_stringWithCString_lengthIMP
eqSel

Up

# EOKeyValueCoding

### Authors

Mircea Oancea (`mircea@jupiter.elcom.pub.ro`)
Mirko Viviani (`mirko.viviani@gmail.com`)
Manuel Guesdon (`mguesdon@oxymium.net`)
David Ayers (`ayers@fsfe.org`)

Date: Generated at 2026-02-03 22:13:20 +0000

Copyright: (C) 1996-2002,2003,2004,2005 Free Software Foundation, Inc.

### Contents -

1. Software documentation for the NSArray(EOKeyValueCoding) category
2. Software documentation for the NSDictionary(EOKeyValueCoding) category
3. Software documentation for the NSMutableDictionary(EOKeyValueCoding) category
4. Software documentation for the NSObject(EOKVCGDL2Additions) informal protocol
5. Software documentation for the NSObject(EOKeyValueCoding) informal protocol
6. Software documentation for the NSObject(EOKeyValueCodingAdditions) informal protocol
7. Software documentation for the NSObject(MacOSX) informal protocol
8. EOKeyValueCoding variables

# Software documentation for the NSArray(EOKeyValueCoding) category

## NSArray(EOKeyValueCoding)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -computeAvgForKey:
- -computeCountForKey:
- -computeMaxForKey:
- -computeMinForKey:
- -computeSumForKey:
- -valueForKey:
- -valueForKeyPath:

### computeAvgForKey:

- (id) computeAvgForKey: (NSString*)key;
Description forthcoming.

### computeCountForKey:

- (id) computeCountForKey: (NSString*)key;
Description forthcoming.

### computeMaxForKey:

- (id) computeMaxForKey: (NSString*)key;
Description forthcoming.

### computeMinForKey:

- (id) computeMinForKey: (NSString*)key;
Description forthcoming.

### computeSumForKey:

- (id) computeSumForKey: (NSString*)key;
Description forthcoming.

### valueForKey:

- (id) valueForKey: (NSString*)key;
Description forthcoming.

### valueForKeyPath:

- (id) valueForKeyPath: (NSString*)keyPath;
Description forthcoming.

# Software documentation for the NSDictionary(EOKeyValueCoding) category

## NSDictionary(EOKeyValueCoding)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -storedValueForKey:
- -storedValueForKeyPath:
- -valueForKey:
- -valueForKeyPath:

### storedValueForKey:

- (id) storedValueForKey: (NSString*)key;
Description forthcoming.

### storedValueForKeyPath:

- (id) storedValueForKeyPath: (NSString*)keyPath;
Description forthcoming.

### valueForKey:

- (id) valueForKey: (NSString*)key;
Description forthcoming.

### valueForKeyPath:

- (id) valueForKeyPath: (NSString*)keyPath;
Description forthcoming.

# Software documentation for the NSMutableDictionary(EOKeyValueCoding) category

## NSMutableDictionary(EOKeyValueCoding)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -takeValue:forKey:

### takeValue: forKey:

- (void) takeValue: (id)value forKey: (NSString*)key;
Description forthcoming.

# Software documentation for the NSObject(EOKVCGDL2Additions) informal protocol

## NSObject(EOKVCGDL2Additions)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -smartTakeValue:forKey:
- -smartTakeValue:forKeyPath:
- -storedValueForKeyPath:
- -storedValuesForKeyPaths:
- -takeStoredValue:forKeyPath:
- -valuesForKeyPaths:

### smartTakeValue: forKey:

- (void) smartTakeValue: (id)object forKey: (NSString*)key;
Description forthcoming.

### smartTakeValue: forKeyPath:

- (void) smartTakeValue: (id)object forKeyPath: (NSString*)keyPath;
Description forthcoming.

### storedValueForKeyPath:

- (id) storedValueForKeyPath: (NSString*)key;
Description forthcoming.

### storedValuesForKeyPaths:

- (NSDictionary*) storedValuesForKeyPaths: (NSArray*)keyPaths;
Description forthcoming.

### takeStoredValue: forKeyPath:

- (void) takeStoredValue: (id)value forKeyPath: (NSString*)key;
Description forthcoming.

### valuesForKeyPaths:

- (NSDictionary*) valuesForKeyPaths: (NSArray*)keyPaths;
Description forthcoming.

# Software documentation for the NSObject(EOKeyValueCoding) informal protocol

## NSObject(EOKeyValueCoding)

> Declared in:
>   EOControl/EOKeyValueCoding.h

GDL2 aims to be compatible with EOF of WebObjects 4.5 and expects to be compiled with gnustep-base or the current version Foundation of Mac OS X together with gnustep-baseadd, the Additions subproject of gnustep-base. As many of the EOKeyValueCoding methods have moved to NSKeyValueCoding, GDL2 merely implements those methods which are not part of NSKeyValueCoding or reimplements those methods to insure WebObjects 4.5 compatibility or augment the behavior for GDL2 specific features.

### Method summary

- +accessInstanceVariablesDirectly
- +flushAllKeyBindings
- +useStoredAccessor
- -handleQueryWithUnboundKey:
- -handleTakeValue:forUnboundKey:
- -storedValueForKey:
- -takeStoredValue:forKey:
- -takeValue:forKey:
- -unableToSetNilForKey:
- -valueForKey:

### accessInstanceVariablesDirectly

+ (BOOL) accessInstanceVariablesDirectly;
Unimplemented here. Relies on NSKeyValueCoding.

### flushAllKeyBindings

+ (void) flushAllKeyBindings;
Does nothing. Key bindings are currently not cached so there is no need to flush them. This method exists for API compatibility.

### useStoredAccessor

+ (BOOL) useStoredAccessor;
Unimplemented here. Relies on NSKeyValueCoding.

### handleQueryWithUnboundKey:

- (id) handleQueryWithUnboundKey: (NSString*)key;
Unimplemented here. Relies on NSKeyValueCoding.

### handleTakeValue: forUnboundKey:

- (void) handleTakeValue: (id)value forUnboundKey: (NSString*)key;
Unimplemented here. Relies on NSKeyValueCoding.

### storedValueForKey:

- (id) storedValueForKey: (NSString*)key;
Unimplemented here. Relies on NSKeyValueCoding.

### takeStoredValue: forKey:

- (void) takeStoredValue: (id)value forKey: (NSString*)key;
Unimplemented here. Relies on NSKeyValueCoding.

### takeValue: forKey:

- (void) takeValue: (id)value forKey: (NSString*)key;
Overrides the implementation of gnustep-base/Foundation this method is currently deprecated in favor of setValue:forKey: yet we aim to maintain WebObjects 4.5 compatibility.

### unableToSetNilForKey:

- (void) unableToSetNilForKey: (NSString*)key;
This method is invoked by the EOKeyValueCoding mechanism when an attempt is made to set an null value for a scalar attribute. Contrary to the TOC of the documentation, this method is called unableToSetNilForKey: and not unableToSetNullForKey:
This implementation raises an NSInvalidArgument exception.
The NSKeyValueCoding setNilValueForKey: is overriden to invoke this method instead. We manipulate the runtime to insure that our implementation of unableToSetNilForKey: is used in favor of the one in gnustep-base or Foundation.

### valueForKey:

- (id) valueForKey: (NSString*)key;
Unimplemented here. Relies on NSKeyValueCoding.

# Software documentation for the NSObject(EOKeyValueCodingAdditions) informal protocol

## NSObject(EOKeyValueCodingAdditions)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -takeValue:forKeyPath:
- -takeValuesFromDictionary:
- -valueForKeyPath:
- -valuesForKeys:

### takeValue: forKeyPath:

- (void) takeValue: (id)value forKeyPath: (NSString*)keyPath;
Overrides the implementation of gnustep-base/Foundation this method is currently deprecated in favor of setValue:forKeyPath: yet we aim to maintain WebObjects 4.5 compatibility.

### takeValuesFromDictionary:

- (void) takeValuesFromDictionary: (NSDictionary*)dictionary;
Overrides the implementation of gnustep-base/Foundation this method is currently deprecated in favor of setValue:forKeyPath: yet we aim to maintain WebObjects 4.5 compatibility.

### valueForKeyPath:

- (id) valueForKeyPath: (NSString*)keyPath;
Unimplemented here. Relies on NSKeyValueCoding.

### valuesForKeys:

- (NSDictionary*) valuesForKeys: (NSArray*)keys;
Unimplemented here. Relies on NSKeyValueCoding.

# Software documentation for the NSObject(MacOSX) informal protocol

## NSObject(MacOSX)

> Declared in:
>   EOControl/EOKeyValueCoding.h

Description forthcoming.

### Method summary

- -takeStoredValuesFromDictionary:

### takeStoredValuesFromDictionary:

- (void) takeStoredValuesFromDictionary: (NSDictionary*)dictionary;
Description forthcoming.

# EOKeyValueCoding variables

### EOTargetObjectUserInfoKey

NSString* EOTargetObjectUserInfoKey;
Description forthcoming.

### EOUnknownUserInfoKey

NSString* EOUnknownUserInfoKey;
Description forthcoming.

Up